#include "BasicBlock.h"
#include "Quadruple.h"
#include "../Compiler.h"

void BasicBlock::finishQuads() {
	for (const auto& q : quads) {
		q->useVariables();
	}
}

const map<VariablePtr, VariablePtr>& BasicBlock::getPhiMapping(const BasicBlockPtr &b) const {
	assert(phi);
	for (uint i = 0; i < in.size(); i++) {
		if (in[i] == b) {
			return phi->phi[i];
		}
	}
	throw runtime_error("BasicBlock::getPhiMapping: In block not found");
}